
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef worldModelGrid3DG_ERROR_H
#define worldModelGrid3DG_ERROR_H

#include "h2errorLib.h"
#include "genom/genomError.h"

#define M_worldModelGrid3DG    (3000)

/* -- MODULES ERRORS -------------------------------------------------- */

/* demo errors */
#define S_worldModelGrid3DG_IMPORT_MAP_FAILURE   H2_ENCODE_ERR(M_worldModelGrid3DG, 1)
#define S_worldModelGrid3DG_Refresh_MAP_FAILURE  H2_ENCODE_ERR(M_worldModelGrid3DG, 2)
#define S_worldModelGrid3DG_SET_ROBOT_BOX_FREE_FAILURE H2_ENCODE_ERR(M_worldModelGrid3DG, 3)
#define S_worldModelGrid3DG_SET_ROBOT_POS_FAILURE H2_ENCODE_ERR(M_worldModelGrid3DG, 4)
#define S_worldModelGrid3DG_CLEAR_MAP_FAILURE    H2_ENCODE_ERR(M_worldModelGrid3DG, 5)
#define S_worldModelGrid3DG_EXPORTING_VRML_MAP_FAILURE H2_ENCODE_ERR(M_worldModelGrid3DG, 6)
#define S_worldModelGrid3DG_EXPORTING_MAP_FAILURE H2_ENCODE_ERR(M_worldModelGrid3DG, 7)
#define S_worldModelGrid3DG_UPDATING_MAP_FAILURE H2_ENCODE_ERR(M_worldModelGrid3DG, 8)
#define S_worldModelGrid3DG_MAKING_SOLID_BOX_FAILURE H2_ENCODE_ERR(M_worldModelGrid3DG, 9)
#define S_worldModelGrid3DG_MAKING_FREE_BOX_FAILURE H2_ENCODE_ERR(M_worldModelGrid3DG, 10)
#define S_worldModelGrid3DG_SETTING_FREE_BOX_FAILURE H2_ENCODE_ERR(M_worldModelGrid3DG, 11)
#define S_worldModelGrid3DG_ALLOCATING_MAP_FAILURE H2_ENCODE_ERR(M_worldModelGrid3DG, 12)
#define S_worldModelGrid3DG_SETTING_CAMERA_PARAMETERS_FAILURE H2_ENCODE_ERR(M_worldModelGrid3DG, 13)
#define S_worldModelGrid3DG_SETTING_SENSITIVITY_FAILURE H2_ENCODE_ERR(M_worldModelGrid3DG, 14)
#define S_worldModelGrid3DG_SETTING_RESOLUTION_FAILURE H2_ENCODE_ERR(M_worldModelGrid3DG, 15)
#define S_worldModelGrid3DG_INITIALIZATION_FAILURE H2_ENCODE_ERR(M_worldModelGrid3DG, 16)


/* std errors */
#define S_worldModelGrid3DG_stdGenoM_ACTIVITY_INTERRUPTED       196666369   /* 3000<<16 | 0x8000 | 100<<8 | 1 */
#define S_worldModelGrid3DG_stdGenoM_TOO_MANY_ACTIVITIES        196666370   /* 3000<<16 | 0x8000 | 100<<8 | 2 */
#define S_worldModelGrid3DG_stdGenoM_ACTIVITY_FAILED            196666371   /* 3000<<16 | 0x8000 | 100<<8 | 3 */
#define S_worldModelGrid3DG_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY 196666372   /* 3000<<16 | 0x8000 | 100<<8 | 4 */
#define S_worldModelGrid3DG_stdGenoM_UNKNOWN_ACTIVITY           196666373   /* 3000<<16 | 0x8000 | 100<<8 | 5 */
#define S_worldModelGrid3DG_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION 196666374   /* 3000<<16 | 0x8000 | 100<<8 | 6 */
#define S_worldModelGrid3DG_stdGenoM_SYSTEM_ERROR               196666375   /* 3000<<16 | 0x8000 | 100<<8 | 7 */
#define S_worldModelGrid3DG_stdGenoM_ACTIVITY_ALREADY_ENDED     196666376   /* 3000<<16 | 0x8000 | 100<<8 | 8 */
#define S_worldModelGrid3DG_stdGenoM_WAIT_INIT_RQST             196666377   /* 3000<<16 | 0x8000 | 100<<8 | 9 */
#define S_worldModelGrid3DG_stdGenoM_CONTROL_CODEL_ERROR        196666378   /* 3000<<16 | 0x8000 | 100<<8 | 10 */
#define S_worldModelGrid3DG_stdGenoM_EXEC_TASK_SUSPENDED        196666379   /* 3000<<16 | 0x8000 | 100<<8 | 11 */
#define S_worldModelGrid3DG_stdGenoM_BAD_BLOCK_TYPE             196666380   /* 3000<<16 | 0x8000 | 100<<8 | 12 */
#define S_worldModelGrid3DG_stdGenoM_BAD_POSTER_TYPE            196666381   /* 3000<<16 | 0x8000 | 100<<8 | 13 */



/* static H2_ERROR[] */
#define WORLDMODELGRID3DG_H2_ERR_MSGS {\
    {"IMPORT_MAP_FAILURE", 1},\
    {"Refresh_MAP_FAILURE", 2},\
    {"SET_ROBOT_BOX_FREE_FAILURE", 3},\
    {"SET_ROBOT_POS_FAILURE", 4},\
    {"CLEAR_MAP_FAILURE", 5},\
    {"EXPORTING_VRML_MAP_FAILURE", 6},\
    {"EXPORTING_MAP_FAILURE", 7},\
    {"UPDATING_MAP_FAILURE", 8},\
    {"MAKING_SOLID_BOX_FAILURE", 9},\
    {"MAKING_FREE_BOX_FAILURE", 10},\
    {"SETTING_FREE_BOX_FAILURE", 11},\
    {"ALLOCATING_MAP_FAILURE", 12},\
    {"SETTING_CAMERA_PARAMETERS_FAILURE", 13},\
    {"SETTING_SENSITIVITY_FAILURE", 14},\
    {"SETTING_RESOLUTION_FAILURE", 15},\
    {"INITIALIZATION_FAILURE", 16},\
}

#ifdef __cplusplus
extern "C" {
#endif

extern int worldModelGrid3DGRecordH2errMsgs(void);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
