
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef worldModelGrid3DG_MSG_LIB_H
#define worldModelGrid3DG_MSG_LIB_H

#include "portLib.h"
#include "csLib.h"
#include "posterLib.h"
 
#include "worldModelGrid3DGType.h"

#define TIME_WAIT_REPLY           /*2000*/ 0
 



/*----------- Tailles des messages et boites aux lettres  ----------*/

/* Taille du buffer utilise dans la bal pour un mesage de taille size
 * (cf servMbox pour UNIX et h2rgnLib pour VXWORKS )
 */


#define BUF_SIZE(size) \
   (size + 4 - (size & 3) + sizeof(LETTER_HDR) + 8)

/**
 ** Boite aux lettres reception requetes 
 **/
#define  WORLDMODELGRID3DG_MBOX_NAME                  genomInstanceName("worldModelGrid3DG")

#define  WORLDMODELGRID3DG_MAX_RQST_SIZE              260

#define  WORLDMODELGRID3DG_MBOX_RQST_SIZE       \
 (BUF_SIZE(WORLDMODELGRID3DG_MAX_RQST_SIZE) * SERV_NMAX_RQST_ID)

/** 
 ** Taille max repliques (serveur)
 **/
#define  WORLDMODELGRID3DG_MAX_INTERMED_REPLY_SIZE   (sizeof(int))

#define  WORLDMODELGRID3DG_MAX_REPLY_SIZE             8

/** 
 ** Taille bal clients pour reception repliques 
 **/
#define  WORLDMODELGRID3DG_CLIENT_MBOX_REPLY_SIZE   \
((BUF_SIZE(WORLDMODELGRID3DG_MAX_REPLY_SIZE) \
   + BUF_SIZE(WORLDMODELGRID3DG_MAX_INTERMED_REPLY_SIZE)) \
 * CLIENT_NMAX_RQST_ID)

/*-------------------------- Liste des requetes  -------------------------*/

#define WORLDMODELGRID3DG_INITIALIZE_RQST 0
#define WORLDMODELGRID3DG_SETRESOLUTION_RQST 1
#define WORLDMODELGRID3DG_SETSENSITIVITY_RQST 2
#define WORLDMODELGRID3DG_SETCAMERAPARAMETERS_RQST 3
#define WORLDMODELGRID3DG_ALLOCATEMAP_RQST 4
#define WORLDMODELGRID3DG_SETFREEBOX_RQST 5
#define WORLDMODELGRID3DG_MAKEBOXFREE_RQST 6
#define WORLDMODELGRID3DG_MAKEBOXSOLID_RQST 7
#define WORLDMODELGRID3DG_UPDATE3DMAP_RQST 8
#define WORLDMODELGRID3DG_EXPORTMAP_RQST 9
#define WORLDMODELGRID3DG_EXPORTVRML_RQST 10
#define WORLDMODELGRID3DG_CLEARMAP_RQST 11
#define WORLDMODELGRID3DG_SETROBOTBOXPOS_RQST 12
#define WORLDMODELGRID3DG_SETROBOTBOXFREE_RQST 13
#define WORLDMODELGRID3DG_REFRESHMAP_RQST 14
#define WORLDMODELGRID3DG_IMPORTMAP_RQST 15
#define WORLDMODELGRID3DG_ABORT_RQST 16


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

STATUS worldModelGrid3DGClientInit (CLIENT_ID *pClientId);

STATUS worldModelGrid3DGClientEnd (CLIENT_ID clientId);

int worldModelGrid3DGAbortRqstSend (CLIENT_ID clientId, 
			   int *pRqstId,
			   int *activity,
			   int replyTimeOut);

int worldModelGrid3DGAbortReplyRcv (CLIENT_ID clientId, 
			   int rqstId, 
			   int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			   int *bilan);

int worldModelGrid3DGAbortRqstAndRcv (CLIENT_ID clientId, 
			     int *activity,
			     int *bilan);




extern STATUS worldModelGrid3DGInitializeRqstSend (CLIENT_ID clientId, int *pRqstId,
					 int *(in_updateNumber),
					 int replyTimeOut);

extern int worldModelGrid3DGInitializeReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int worldModelGrid3DGInitializeRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					int *(in_updateNumber), 
					
					int *activity, int *bilan);

extern int worldModelGrid3DGInitializeRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					int *(in_updateNumber), 
					
					int *activity,
					int *bilan);




extern STATUS worldModelGrid3DGSetResolutionRqstSend (CLIENT_ID clientId, int *pRqstId,
					 double *(in_resolution),
					 int replyTimeOut);

extern int worldModelGrid3DGSetResolutionReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int worldModelGrid3DGSetResolutionRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					double *(in_resolution), 
					
					int *activity, int *bilan);

extern int worldModelGrid3DGSetResolutionRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					double *(in_resolution), 
					
					int *activity,
					int *bilan);




extern STATUS worldModelGrid3DGSetSensitivityRqstSend (CLIENT_ID clientId, int *pRqstId,
					 unsigned int *(in_sensitivity),
					 int replyTimeOut);

extern int worldModelGrid3DGSetSensitivityReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int worldModelGrid3DGSetSensitivityRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					unsigned int *(in_sensitivity), 
					
					int *activity, int *bilan);

extern int worldModelGrid3DGSetSensitivityRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					unsigned int *(in_sensitivity), 
					
					int *activity,
					int *bilan);




extern STATUS worldModelGrid3DGSetCameraParametersRqstSend (CLIENT_ID clientId, int *pRqstId,
					 vec3 *(in_cameraParameters),
					 int replyTimeOut);

extern int worldModelGrid3DGSetCameraParametersReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int worldModelGrid3DGSetCameraParametersRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					vec3 *(in_cameraParameters), 
					
					int *activity, int *bilan);

extern int worldModelGrid3DGSetCameraParametersRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					vec3 *(in_cameraParameters), 
					
					int *activity,
					int *bilan);




extern STATUS worldModelGrid3DGAllocateMapRqstSend (CLIENT_ID clientId, int *pRqstId,
					 boxArea *(in_mapArea),
					 int replyTimeOut);

extern int worldModelGrid3DGAllocateMapReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int worldModelGrid3DGAllocateMapRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					boxArea *(in_mapArea), 
					
					int *activity, int *bilan);

extern int worldModelGrid3DGAllocateMapRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					boxArea *(in_mapArea), 
					
					int *activity,
					int *bilan);




extern STATUS worldModelGrid3DGSetFreeBoxRqstSend (CLIENT_ID clientId, int *pRqstId,
					 boxArea *(in_freeBox),
					 int replyTimeOut);

extern int worldModelGrid3DGSetFreeBoxReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int worldModelGrid3DGSetFreeBoxRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					boxArea *(in_freeBox), 
					
					int *activity, int *bilan);

extern int worldModelGrid3DGSetFreeBoxRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					boxArea *(in_freeBox), 
					
					int *activity,
					int *bilan);




extern STATUS worldModelGrid3DGMakeBoxFreeRqstSend (CLIENT_ID clientId, int *pRqstId,
					 boxArea *(in_box),
					 int replyTimeOut);

extern int worldModelGrid3DGMakeBoxFreeReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int worldModelGrid3DGMakeBoxFreeRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					boxArea *(in_box), 
					
					int *activity, int *bilan);

extern int worldModelGrid3DGMakeBoxFreeRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					boxArea *(in_box), 
					
					int *activity,
					int *bilan);




extern STATUS worldModelGrid3DGMakeBoxSolidRqstSend (CLIENT_ID clientId, int *pRqstId,
					 boxArea *(in_box),
					 int replyTimeOut);

extern int worldModelGrid3DGMakeBoxSolidReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int worldModelGrid3DGMakeBoxSolidRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					boxArea *(in_box), 
					
					int *activity, int *bilan);

extern int worldModelGrid3DGMakeBoxSolidRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					boxArea *(in_box), 
					
					int *activity,
					int *bilan);




extern STATUS worldModelGrid3DGUpdate3DMapRqstSend (CLIENT_ID clientId, int *pRqstId,
					 imageRange *(in_imageID),
					 int replyTimeOut);

extern int worldModelGrid3DGUpdate3DMapReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int worldModelGrid3DGUpdate3DMapRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					imageRange *(in_imageID), 
					
					int *activity, int *bilan);

extern int worldModelGrid3DGUpdate3DMapRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					imageRange *(in_imageID), 
					
					int *activity,
					int *bilan);




extern STATUS worldModelGrid3DGExportMapRqstSend (CLIENT_ID clientId, int *pRqstId,
					 fileNameAddress *(in_exportDirectory),
					 int replyTimeOut);

extern int worldModelGrid3DGExportMapReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int worldModelGrid3DGExportMapRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					fileNameAddress *(in_exportDirectory), 
					
					int *activity, int *bilan);

extern int worldModelGrid3DGExportMapRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					fileNameAddress *(in_exportDirectory), 
					
					int *activity,
					int *bilan);




extern STATUS worldModelGrid3DGExportVRMLRqstSend (CLIENT_ID clientId, int *pRqstId,
					 exportSetting *(in_setting),
					 int replyTimeOut);

extern int worldModelGrid3DGExportVRMLReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int worldModelGrid3DGExportVRMLRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					exportSetting *(in_setting), 
					
					int *activity, int *bilan);

extern int worldModelGrid3DGExportVRMLRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					exportSetting *(in_setting), 
					
					int *activity,
					int *bilan);




extern STATUS worldModelGrid3DGClearMapRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int worldModelGrid3DGClearMapReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int worldModelGrid3DGClearMapRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int worldModelGrid3DGClearMapRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS worldModelGrid3DGSetRobotBoxPosRqstSend (CLIENT_ID clientId, int *pRqstId,
					 pos *(in_robotPos),
					 int replyTimeOut);

extern int worldModelGrid3DGSetRobotBoxPosReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int worldModelGrid3DGSetRobotBoxPosRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					pos *(in_robotPos), 
					
					int *activity, int *bilan);

extern int worldModelGrid3DGSetRobotBoxPosRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					pos *(in_robotPos), 
					
					int *activity,
					int *bilan);




extern STATUS worldModelGrid3DGSetRobotBoxFreeRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int worldModelGrid3DGSetRobotBoxFreeReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int worldModelGrid3DGSetRobotBoxFreeRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int worldModelGrid3DGSetRobotBoxFreeRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS worldModelGrid3DGRefreshMapRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int worldModelGrid3DGRefreshMapReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int worldModelGrid3DGRefreshMapRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int worldModelGrid3DGRefreshMapRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS worldModelGrid3DGImportMapRqstSend (CLIENT_ID clientId, int *pRqstId,
					 fileNameAddress *(in_importFile),
					 int replyTimeOut);

extern int worldModelGrid3DGImportMapReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int worldModelGrid3DGImportMapRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					fileNameAddress *(in_importFile), 
					
					int *activity, int *bilan);

extern int worldModelGrid3DGImportMapRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					fileNameAddress *(in_importFile), 
					
					int *activity,
					int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* worldModelGrid3DG_MSG_LIB_H */

