
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef worldModelGrid3DG_POSTER_LIB_H
#define worldModelGrid3DG_POSTER_LIB_H

#include "posterLib.h"
#include "genom/genom.h"

/* Types definis ou utilises par le module */
#include "worldModelGrid3DGType.h"
#include "worldModelGrid3DGError.h"

/* 
 * Definition de la SDI_C 
*/
typedef struct {
  CNTRL_TASK_DESCRIPTION cntrlTask;
  EXEC_TASK_DESCRIPTION execTaskTab[WORLDMODELGRID3DG_NB_EXEC_TASK];
  ACTIVITY_DESCRIPTION activityTab[MAX_ACTIVITIES];
} WORLDMODELGRID3DG_CNTRL_STR;

/* For consistency with other posters */
typedef WORLDMODELGRID3DG_CNTRL_STR WORLDMODELGRID3DG_CNTRL_POSTER_STR;
 
/* 
 * Definition des structures de posters
 */
#include "worldModelGrid3DGPosterLibStruct.h"



/* Posters */
#define WORLDMODELGRID3DG_CNTRL_POSTER_NAME genomInstanceSuffixName("worldModelGrid3DG", "Cntrl")
#define WORLDMODELGRID3DG_GRIDTHREEDMAP_POSTER_NAME genomInstanceSuffixName("worldModelGrid3DG", "GriDThreeDMap")


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif
extern STATUS worldModelGrid3DGPosterInit ( void );
extern POSTER_ID worldModelGrid3DGCntrlPosterID ();
extern STATUS worldModelGrid3DGCntrlPosterRead ( WORLDMODELGRID3DG_CNTRL_STR *worldModelGrid3DGCntrlStrId );
extern STATUS worldModelGrid3DGCntrlPosterInit ( void );
extern STATUS worldModelGrid3DGCntrlInstancePosterRead(const char *name, WORLDMODELGRID3DG_CNTRL_STR *worldModelGrid3DGCntrlStrId);
extern STATUS worldModelGrid3DGGriDThreeDMapPosterInit ( void );
extern POSTER_ID worldModelGrid3DGGriDThreeDMapPosterID ( void );
extern STATUS worldModelGrid3DGGriDThreeDMapPosterRead ( WORLDMODELGRID3DG_GRIDTHREEDMAP_POSTER_STR *x );
extern STATUS worldModelGrid3DGGriDThreeDMapInstancePosterRead ( const char *, WORLDMODELGRID3DG_GRIDTHREEDMAP_POSTER_STR * );
extern STATUS worldModelGrid3DGGriDThreeDMapgrid3DMapPosterRead ( map3D *grid3DMap );
extern STATUS worldModelGrid3DGGriDThreeDMapgrid3DMapInstancePosterRead( const char *, map3D * );
#ifdef __cplusplus
}
#endif
#endif

