
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

/* 
 * worldModelGrid3DGType.h:     La SDI_F de worldModelGrid3DG
 *
 * Utilise par le module et par les clients
 * (inclut dans worldModelGrid3DGMsgLib.h et worldModelGrid3DGPosterLib.h)
 * 
 */

#ifndef worldModelGrid3DG_TYPE_H
#define worldModelGrid3DG_TYPE_H

#include "genom/modules.h"
#include "worldModelGrid3DGError.h"

/* Nombre de tache d'execution de ce module */
#define WORLDMODELGRID3DG_NB_EXEC_TASK                   (1)


#endif
#ifndef worldModelGrid3DG_TYPE1_H
#define worldModelGrid3DG_TYPE1_H

#include "worldModelGrid3DGStruct.h"
#include "/opt/openrobots/include/pom/pomStruct.h"

/*
 * Structure de donnees interne
 */
typedef struct worldModelGrid3DG_STR {
	int updateFlag;
	int updateNumber;
	map3D grid3DMap;
	pos robotPos;
	boxArea mapArea;
	boxArea freeBox;
	boxArea box;
	double resolution;
	unsigned int sensitivity;
	imageRange imageID;
	vec3 cameraParameters;
	fileNameAddress importFile;
	fileNameAddress exportDirectory;
	exportSetting setting;
	WORLD_MODEL_GRID3D_POSTER_NAME imagePosterName;
} worldModelGrid3DG_STR;


#endif

