
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] worldModelGrid3DGInstall] >= 0 } {
    interp expose {} worldModelGrid3DGInstall
}

proc ::worldModelGrid3DGInstall { name } {
    foreach rqst { "Initialize" "SetResolution" "SetSensitivity" "SetCameraParameters" "AllocateMap" "SetFreeBox" "MakeBoxFree" "MakeBoxSolid" "Update3DMap" "ExportMap" "ExportVRML" "ClearMap" "SetRobotBoxPos" "SetRobotBoxFree" "RefreshMap" "ImportMap" "GriDThreeDMapgrid3DMapPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} worldModelGrid3DG$rqst $name
    }
}

interp hide {} worldModelGrid3DGInstall




# Initialize ----------------------------------------------------------

if { [lsearch [interp hidden] worldModelGrid3DGInitialize] >= 0 } {
    interp expose {} worldModelGrid3DGInitialize
}
if { [lsearch [interp hidden] worldModelGrid3DGInitializeFormatOutput] >= 0 } {
    interp expose {} worldModelGrid3DGInitializeFormatOutput
}

proc ::worldModelGrid3DGInitialize { name args } {
    set format {}
    lappend format [list int "updateNumber" 0 ]

    return [ ::cs::rqstSend "${name}" "Initialize" \
	"Initializing pome and stereopixel" \
	"int updateNumber\n" \
	1 \
	$format \
	$args ]
}


proc ::worldModelGrid3DGInitializeFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} worldModelGrid3DGInitialize
interp hide {} worldModelGrid3DGInitializeFormatOutput





# SetResolution ----------------------------------------------------------

if { [lsearch [interp hidden] worldModelGrid3DGSetResolution] >= 0 } {
    interp expose {} worldModelGrid3DGSetResolution
}
if { [lsearch [interp hidden] worldModelGrid3DGSetResolutionFormatOutput] >= 0 } {
    interp expose {} worldModelGrid3DGSetResolutionFormatOutput
}

proc ::worldModelGrid3DGSetResolution { name args } {
    set format {}
    lappend format [list double "resolution" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetResolution" \
	"Setting the resolution of the 3D Map in \[m\]." \
	"double resolution\n" \
	1 \
	$format \
	$args ]
}


proc ::worldModelGrid3DGSetResolutionFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} worldModelGrid3DGSetResolution
interp hide {} worldModelGrid3DGSetResolutionFormatOutput





# SetSensitivity ----------------------------------------------------------

if { [lsearch [interp hidden] worldModelGrid3DGSetSensitivity] >= 0 } {
    interp expose {} worldModelGrid3DGSetSensitivity
}
if { [lsearch [interp hidden] worldModelGrid3DGSetSensitivityFormatOutput] >= 0 } {
    interp expose {} worldModelGrid3DGSetSensitivityFormatOutput
}

proc ::worldModelGrid3DGSetSensitivity { name args } {
    set format {}
    lappend format [list int "sensitivity" 0 ]

    return [ ::cs::rqstSend "${name}" "SetSensitivity" \
	"Setting the Sensitivity of 3D Voxel." \
	"unsigned int sensitivity\n" \
	1 \
	$format \
	$args ]
}


proc ::worldModelGrid3DGSetSensitivityFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} worldModelGrid3DGSetSensitivity
interp hide {} worldModelGrid3DGSetSensitivityFormatOutput





# SetCameraParameters ----------------------------------------------------------

if { [lsearch [interp hidden] worldModelGrid3DGSetCameraParameters] >= 0 } {
    interp expose {} worldModelGrid3DGSetCameraParameters
}
if { [lsearch [interp hidden] worldModelGrid3DGSetCameraParametersFormatOutput] >= 0 } {
    interp expose {} worldModelGrid3DGSetCameraParametersFormatOutput
}

proc ::worldModelGrid3DGSetCameraParameters { name args } {
    set format {}
    lappend format [list double "cameraParameters.widthAngle" 0.0 ]
    lappend format [list double "cameraParameters.heightAngle" 0.0 ]
    lappend format [list double "cameraParameters.observableDistance" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetCameraParameters" \
	"Setting the Camera Parametres (WidthAngle, HeightAngle , ObservableDistance)" \
	"vec3\n| double widthAngle\n| double heightAngle\n| double observableDistance\n" \
	3 \
	$format \
	$args ]
}


proc ::worldModelGrid3DGSetCameraParametersFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} worldModelGrid3DGSetCameraParameters
interp hide {} worldModelGrid3DGSetCameraParametersFormatOutput





# AllocateMap ----------------------------------------------------------

if { [lsearch [interp hidden] worldModelGrid3DGAllocateMap] >= 0 } {
    interp expose {} worldModelGrid3DGAllocateMap
}
if { [lsearch [interp hidden] worldModelGrid3DGAllocateMapFormatOutput] >= 0 } {
    interp expose {} worldModelGrid3DGAllocateMapFormatOutput
}

proc ::worldModelGrid3DGAllocateMap { name args } {
    set format {}
    lappend format [list double "mapArea.xStart" 0.0 ]
    lappend format [list double "mapArea.yStart" 0.0 ]
    lappend format [list double "mapArea.zStart" 0.0 ]
    lappend format [list double "mapArea.xEnd" 0.0 ]
    lappend format [list double "mapArea.yEnd" 0.0 ]
    lappend format [list double "mapArea.zEnd" 0.0 ]

    return [ ::cs::rqstSend "${name}" "AllocateMap" \
	"Setting the size of the 3D Map in \[m\]." \
	"boxArea\n| double xStart\n| double yStart\n| double zStart\n| double xEnd\n| double yEnd\n| double zEnd\n" \
	6 \
	$format \
	$args ]
}


proc ::worldModelGrid3DGAllocateMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} worldModelGrid3DGAllocateMap
interp hide {} worldModelGrid3DGAllocateMapFormatOutput





# SetFreeBox ----------------------------------------------------------

if { [lsearch [interp hidden] worldModelGrid3DGSetFreeBox] >= 0 } {
    interp expose {} worldModelGrid3DGSetFreeBox
}
if { [lsearch [interp hidden] worldModelGrid3DGSetFreeBoxFormatOutput] >= 0 } {
    interp expose {} worldModelGrid3DGSetFreeBoxFormatOutput
}

proc ::worldModelGrid3DGSetFreeBox { name args } {
    set format {}
    lappend format [list double "freeBox.xStart" 0.0 ]
    lappend format [list double "freeBox.yStart" 0.0 ]
    lappend format [list double "freeBox.zStart" 0.0 ]
    lappend format [list double "freeBox.xEnd" 0.0 ]
    lappend format [list double "freeBox.yEnd" 0.0 ]
    lappend format [list double "freeBox.zEnd" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetFreeBox" \
	"Setting the size of the 3D FreeBoxin the Map in \[m\]." \
	"boxArea\n| double xStart\n| double yStart\n| double zStart\n| double xEnd\n| double yEnd\n| double zEnd\n" \
	6 \
	$format \
	$args ]
}


proc ::worldModelGrid3DGSetFreeBoxFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} worldModelGrid3DGSetFreeBox
interp hide {} worldModelGrid3DGSetFreeBoxFormatOutput





# MakeBoxFree ----------------------------------------------------------

if { [lsearch [interp hidden] worldModelGrid3DGMakeBoxFree] >= 0 } {
    interp expose {} worldModelGrid3DGMakeBoxFree
}
if { [lsearch [interp hidden] worldModelGrid3DGMakeBoxFreeFormatOutput] >= 0 } {
    interp expose {} worldModelGrid3DGMakeBoxFreeFormatOutput
}

proc ::worldModelGrid3DGMakeBoxFree { name args } {
    set format {}
    lappend format [list double "box.xStart" 0.0 ]
    lappend format [list double "box.yStart" 0.0 ]
    lappend format [list double "box.zStart" 0.0 ]
    lappend format [list double "box.xEnd" 0.0 ]
    lappend format [list double "box.yEnd" 0.0 ]
    lappend format [list double "box.zEnd" 0.0 ]

    return [ ::cs::rqstSend "${name}" "MakeBoxFree" \
	"Change the status of a volume to free\[m\] ." \
	"boxArea\n| double xStart\n| double yStart\n| double zStart\n| double xEnd\n| double yEnd\n| double zEnd\n" \
	6 \
	$format \
	$args ]
}


proc ::worldModelGrid3DGMakeBoxFreeFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} worldModelGrid3DGMakeBoxFree
interp hide {} worldModelGrid3DGMakeBoxFreeFormatOutput





# MakeBoxSolid ----------------------------------------------------------

if { [lsearch [interp hidden] worldModelGrid3DGMakeBoxSolid] >= 0 } {
    interp expose {} worldModelGrid3DGMakeBoxSolid
}
if { [lsearch [interp hidden] worldModelGrid3DGMakeBoxSolidFormatOutput] >= 0 } {
    interp expose {} worldModelGrid3DGMakeBoxSolidFormatOutput
}

proc ::worldModelGrid3DGMakeBoxSolid { name args } {
    set format {}
    lappend format [list double "box.xStart" 0.0 ]
    lappend format [list double "box.yStart" 0.0 ]
    lappend format [list double "box.zStart" 0.0 ]
    lappend format [list double "box.xEnd" 0.0 ]
    lappend format [list double "box.yEnd" 0.0 ]
    lappend format [list double "box.zEnd" 0.0 ]

    return [ ::cs::rqstSend "${name}" "MakeBoxSolid" \
	"Change the status of a volume to solid\[m\]." \
	"boxArea\n| double xStart\n| double yStart\n| double zStart\n| double xEnd\n| double yEnd\n| double zEnd\n" \
	6 \
	$format \
	$args ]
}


proc ::worldModelGrid3DGMakeBoxSolidFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} worldModelGrid3DGMakeBoxSolid
interp hide {} worldModelGrid3DGMakeBoxSolidFormatOutput





# Update3DMap ----------------------------------------------------------

if { [lsearch [interp hidden] worldModelGrid3DGUpdate3DMap] >= 0 } {
    interp expose {} worldModelGrid3DGUpdate3DMap
}
if { [lsearch [interp hidden] worldModelGrid3DGUpdate3DMapFormatOutput] >= 0 } {
    interp expose {} worldModelGrid3DGUpdate3DMapFormatOutput
}

proc ::worldModelGrid3DGUpdate3DMap { name args } {
    set format {}
    lappend format [list int "imageID.startNumber" 0 ]
    lappend format [list int "imageID.endNumber" 0 ]

    return [ ::cs::rqstSend "${name}" "Update3DMap" \
	"This request update the camera position and finaly update the GridMap" \
	"imageRange\n| int startNumber\n| int endNumber\n" \
	2 \
	$format \
	$args ]
}


proc ::worldModelGrid3DGUpdate3DMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} worldModelGrid3DGUpdate3DMap
interp hide {} worldModelGrid3DGUpdate3DMapFormatOutput





# ExportMap ----------------------------------------------------------

if { [lsearch [interp hidden] worldModelGrid3DGExportMap] >= 0 } {
    interp expose {} worldModelGrid3DGExportMap
}
if { [lsearch [interp hidden] worldModelGrid3DGExportMapFormatOutput] >= 0 } {
    interp expose {} worldModelGrid3DGExportMapFormatOutput
}

proc ::worldModelGrid3DGExportMap { name args } {
    set format {}
    lappend format [list string "exportDirectory.name" "" ]

    return [ ::cs::rqstSend "${name}" "ExportMap" \
	"exporting a txt file for save the information" \
	"fileNameAddress\n| char name\[256\]\n" \
	1 \
	$format \
	$args ]
}


proc ::worldModelGrid3DGExportMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} worldModelGrid3DGExportMap
interp hide {} worldModelGrid3DGExportMapFormatOutput





# ExportVRML ----------------------------------------------------------

if { [lsearch [interp hidden] worldModelGrid3DGExportVRML] >= 0 } {
    interp expose {} worldModelGrid3DGExportVRML
}
if { [lsearch [interp hidden] worldModelGrid3DGExportVRMLFormatOutput] >= 0 } {
    interp expose {} worldModelGrid3DGExportVRMLFormatOutput
}

proc ::worldModelGrid3DGExportVRML { name args } {
    set format {}
    lappend format [list int "setting.exportMode" 0 ]
    lappend format [list string "setting.exportAddrees.name" "" ]

    return [ ::cs::rqstSend "${name}" "ExportVRML" \
	"exporting a vrml file for visualization" \
	"exportSetting\n| int exportMode\n| fileNameAddress\n| | char name\[256\]\n" \
	2 \
	$format \
	$args ]
}


proc ::worldModelGrid3DGExportVRMLFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} worldModelGrid3DGExportVRML
interp hide {} worldModelGrid3DGExportVRMLFormatOutput





# ClearMap ----------------------------------------------------------

if { [lsearch [interp hidden] worldModelGrid3DGClearMap] >= 0 } {
    interp expose {} worldModelGrid3DGClearMap
}
if { [lsearch [interp hidden] worldModelGrid3DGClearMapFormatOutput] >= 0 } {
    interp expose {} worldModelGrid3DGClearMapFormatOutput
}

proc ::worldModelGrid3DGClearMap { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "ClearMap" \
	"reseting the map" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::worldModelGrid3DGClearMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} worldModelGrid3DGClearMap
interp hide {} worldModelGrid3DGClearMapFormatOutput





# SetRobotBoxPos ----------------------------------------------------------

if { [lsearch [interp hidden] worldModelGrid3DGSetRobotBoxPos] >= 0 } {
    interp expose {} worldModelGrid3DGSetRobotBoxPos
}
if { [lsearch [interp hidden] worldModelGrid3DGSetRobotBoxPosFormatOutput] >= 0 } {
    interp expose {} worldModelGrid3DGSetRobotBoxPosFormatOutput
}

proc ::worldModelGrid3DGSetRobotBoxPos { name args } {
    set format {}
    lappend format [list double "robotPos.x" 0.0 ]
    lappend format [list double "robotPos.y" 0.0 ]
    lappend format [list double "robotPos.theta" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetRobotBoxPos" \
	"Setting the position of robot in the map" \
	"pos\n| double x\n| double y\n| double theta\n" \
	3 \
	$format \
	$args ]
}


proc ::worldModelGrid3DGSetRobotBoxPosFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} worldModelGrid3DGSetRobotBoxPos
interp hide {} worldModelGrid3DGSetRobotBoxPosFormatOutput





# SetRobotBoxFree ----------------------------------------------------------

if { [lsearch [interp hidden] worldModelGrid3DGSetRobotBoxFree] >= 0 } {
    interp expose {} worldModelGrid3DGSetRobotBoxFree
}
if { [lsearch [interp hidden] worldModelGrid3DGSetRobotBoxFreeFormatOutput] >= 0 } {
    interp expose {} worldModelGrid3DGSetRobotBoxFreeFormatOutput
}

proc ::worldModelGrid3DGSetRobotBoxFree { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "SetRobotBoxFree" \
	"set the robot bounding box free" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::worldModelGrid3DGSetRobotBoxFreeFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} worldModelGrid3DGSetRobotBoxFree
interp hide {} worldModelGrid3DGSetRobotBoxFreeFormatOutput





# RefreshMap ----------------------------------------------------------

if { [lsearch [interp hidden] worldModelGrid3DGRefreshMap] >= 0 } {
    interp expose {} worldModelGrid3DGRefreshMap
}
if { [lsearch [interp hidden] worldModelGrid3DGRefreshMapFormatOutput] >= 0 } {
    interp expose {} worldModelGrid3DGRefreshMapFormatOutput
}

proc ::worldModelGrid3DGRefreshMap { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "RefreshMap" \
	"erasing noise from map" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::worldModelGrid3DGRefreshMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} worldModelGrid3DGRefreshMap
interp hide {} worldModelGrid3DGRefreshMapFormatOutput





# ImportMap ----------------------------------------------------------

if { [lsearch [interp hidden] worldModelGrid3DGImportMap] >= 0 } {
    interp expose {} worldModelGrid3DGImportMap
}
if { [lsearch [interp hidden] worldModelGrid3DGImportMapFormatOutput] >= 0 } {
    interp expose {} worldModelGrid3DGImportMapFormatOutput
}

proc ::worldModelGrid3DGImportMap { name args } {
    set format {}
    lappend format [list string "importFile.name" "" ]

    return [ ::cs::rqstSend "${name}" "ImportMap" \
	"Importing the map" \
	"fileNameAddress\n| char name\[256\]\n" \
	1 \
	$format \
	$args ]
}


proc ::worldModelGrid3DGImportMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} worldModelGrid3DGImportMap
interp hide {} worldModelGrid3DGImportMapFormatOutput





# GriDThreeDMapgrid3DMap ----------------------------------------------------------

if { [lsearch [interp hidden] worldModelGrid3DGGriDThreeDMapgrid3DMapPosterRead] >= 0 } {
    interp expose {} worldModelGrid3DGGriDThreeDMapgrid3DMapPosterRead
}
if { [lsearch [interp hidden] worldModelGrid3DGGriDThreeDMapgrid3DMapPosterFormatOutput] >= 0 } {
    interp expose {} worldModelGrid3DGGriDThreeDMapgrid3DMapPosterFormatOutput
}

proc ::worldModelGrid3DGGriDThreeDMapgrid3DMapPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "GriDThreeDMapgrid3DMap" \
	"map3D\n| boxArea\n| | double xStart\n| | double yStart\n| | double zStart\n| | double xEnd\n| | double yEnd\n| | double zEnd\n| int nbOfGridX\n| int nbOfGridY\n| int nbOfGridZ\n| double map3DResolution\n| char gridvalue\[1000000\]\n" \
	$args ]
}


proc ::worldModelGrid3DGGriDThreeDMapgrid3DMapPosterFormatOutput { list } {
    set format { {} status { } { grid3DMap { } { map3DBoxArea { } xStart { } yStart { } zStart { } xEnd { } yEnd { } zEnd } { } nbOfGridX { } nbOfGridY { } nbOfGridZ { } map3DResolution { } gridvalue } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} worldModelGrid3DGGriDThreeDMapgrid3DMapPosterRead
interp hide {} worldModelGrid3DGGriDThreeDMapgrid3DMapPosterFormatOutput


